{-# LANGUAGE TypeOperators #-}
{-# LANGUAGE DataKinds #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE MultiParamTypeClasses #-}

module PUBMED.Client where

import Servant.API
import Servant.Client

import Data.Proxy (Proxy(..))
import Data.ByteString.Lazy (ByteString)

import qualified Network.HTTP.Media as M
import qualified Data.Text as T

data DB = PUBMED

newtype BsXml = BsXml ByteString
  deriving (Show)

instance Accept BsXml where
  contentType _ = "text" M.// "xml"

instance MimeUnrender BsXml BsXml where
  mimeUnrender _ = Right . BsXml

type PUBMEDAPI =
  "esearch.fcgi"
--  :> QueryParam "db" DB
-- not mandatory since the base db is pubmed
  :> QueryParam "term" T.Text
  :> Get '[BsXml] BsXml
  :<|>
  "efetch.fcgi"
  :> QueryParam "db" T.Text
  :> QueryParam "retmode" T.Text
  :> QueryParams "id" T.Text
  :> Get '[BsXml] BsXml

pubmedApi :: Proxy PUBMEDAPI
pubmedApi = Proxy

search :: Maybe T.Text
  -> ClientM BsXml
fetch :: Maybe T.Text
  -> Maybe T.Text
  -> [T.Text]
  -> ClientM BsXml
search :<|> fetch = client pubmedApi
